// PCM TEST
// using 24kB 8bit unsigned PCM raw mono audio data @ 4kHz sample rate


#pragma target(C1P)
#pragma encoding(ascii)
#pragma cpu(mos6502)

#include "defs.h"
#include "asm_subs.h"

#define C1P
#pragma code_seg(Code)

#include <C1P.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "print_cp1.h"
#include "audio_data.h"


void main() {
   
   zp_vector=zeropage;
   save_zeropage();                           // Save All Zeropage
   unsigned ram=0;
   unsigned cnt=0;
   unsigned byte c=0;
   const char * LATCH = 0xD800;
   const char * DAC = 0xDF00;
   *LATCH=0x00;
   *DAC=0x80;
   print_set_screen(0xD000,64);
   cls_screen(0x20);
   print_str_ln("PCM Sound Player V1.0");
   print_ln();
   print_str_ln("Press <ENTER> to play");
   call_external(0xFD00);
   do{
           delay_ms(1);
           *LATCH=0x10;
           for(ram=0;ram<23804;ram++) {
                *DAC=rawData[ram];                              // 8 Bit version
 //               *DAC=(rawData[ram]>>2)&0x3C;                    // 4 Bit version
                delay_200();
           }
           *LATCH=0x00;
   }while(true);
   zp_vector=zeropage;                       // Restore Zeropage
   restore_zeropage();
}
